/***************************************************************************
 * CDIFS.C - CDIFS fs functions jumptables                                 *
 * ---------------------------------------                                 *
 *                                                                         *
 * VCDID - CD-I filesystem driver                                          *
 * (c) 1997 - 1999 Vahur Sinijrv                                          *
 *                                                                         *
 * You are free to use any part of this source code, provided              *
 * that credit is given to author in such cases.                           *
 ***************************************************************************/

#include <basedef.h>
#include <vmm.h>
#include <error.h>
#include "vcdid.h"

#pragma VxD_PAGEABLE_CODE_SEG
#pragma VxD_PAGEABLE_DATA_SEG

DWORD _cdecl CDIFS_Fail( pioreq p )
{
    p->ir_error = ERROR_NOT_SUPPORTED;
    return ERROR_NOT_SUPPORTED;
}

DWORD _cdecl CDIFS_FailWRP( pioreq p )
{
    p->ir_error = ERROR_WRITE_PROTECT;
    return ERROR_WRITE_PROTECT;
}

DWORD _cdecl CDIFS_Success( pioreq p )
{
    p->ir_error = NO_ERROR;
    return NO_ERROR;
}

struct volfunc cdifs_volfunc = {
    IFS_VERSION,
    IFS_REVISION,
    NUM_VOLFUNC,
    { CDIFS_FailWRP,                    // Delete
      CDIFS_Dir,                        // Dir
      CDIFS_FileAttributes,             // FileAttributes
      CDIFS_Success,                    // FlushVolume
      CDIFS_GetDiskInfo,                // GetDiskInfo
      CDIFS_OpenFile,                   // OpenFile
      CDIFS_FailWRP,                    // RenameFile
      CDIFS_Fail,                       // SearchFile
      CDIFS_QueryResourceInfo,          // QueryResourceInfo
      CDIFS_Unmount,                    // DisconnectResource
      CDIFS_Fail,                       // UNCPipeRequest
      CDIFS_IOCtl16,                    // Ioctl16Drive
      CDIFS_Fail,                       // GetDiskParams
      CDIFS_FindFirstFile,              // FindFirstFile
      CDIFS_DirectDiskIO                // DirectDiskIO
    }
};

struct hndlmisc cdifs_hndlmisc = {
    IFS_VERSION,
    IFS_REVISION,
    NUM_HNDLMISC,
    { CDIFS_Fail,                       // Seek
      CDIFS_FindClose,                  // Close
      CDIFS_Fail,                       // Commit
      CDIFS_Fail,                       // FileLocks
      CDIFS_Fail,                       // FileTimes
      CDIFS_Fail,                       // PipeRequest
      CDIFS_Fail,                       // HandleInfo
      CDIFS_Fail                        // EnumerateHandle
    }
};

struct hndlmisc cdifs_hndlopen = {
    IFS_VERSION,
    IFS_REVISION,
    NUM_HNDLMISC,
    { CDIFS_Seek,                       // Seek
      CDIFS_Close,                      // Close
      CDIFS_Success,                    // Commit
      CDIFS_FileLocks,                  // FileLocks
      CDIFS_FileTimes,                  // FileTimes
      CDIFS_Fail,                       // PipeRequest
      CDIFS_HandleInfo,                 // HandleInfo
      CDIFS_EnumerateHandle             // EnumerateHandle
    }
};

