;Ϳ
;  IOCTL16.ASM - 16-bit IOCTL implementation                    
;                                                               
;  VCDID - CD-I filesystem driver                               
;  (c) 1997 - 1999 Vahur Sinijrv                               
;                                                               
;  You are free to use any part of this source code, provided   
;  that credit is given to author in such cases.                
;
.386p
        .XLIST
        INCLUDE vmm.inc
        MASM=1
        INCLUDE blockdev.inc
        INCLUDE ios.inc
        INCLUDE ior.inc
        INCLUDE ifs.inc

        INCLUDE vcdid.inc

VxD_CODE_SEG

        extern  _AllocIOP: near, _FreeIOP: near

SERIAL_NO       STRUC
ser_info_level  dw      ?
ser_serial_no   dd      ?
ser_vol_label   db      11 dup(?)
ser_fs_type     db      8 dup(?)
SERIAL_NO       ENDS

;----------------------------------------------------------
; GetSerial
;
; Handle int 21, AX=440D, CX=0866, get volume serial number
;
; IN:     EBX = ptr to ioreq
;         EDI = ptr to CDIFS_VOLUME
;         EDX = ptr to CLIENT_REGS
;         ECX = ptr to client buffer
;
; OUT:    EAX = NO_ERROR
; MODIFY: ESI, EDI, ECX, EAX
;----------------------------------------------------------
GetSerial       PROC
                mov     [ecx].ser_info_level, 0
                mov     eax, [edi].vi_serial
                mov     [ecx].ser_serial_no, eax

                ;
                ; Copy volume label
                ;
                push    ecx

                lea     esi, [ecx].ser_vol_label
                mov     ecx, [edi].vi_label_size
                shr     ecx, 1                          ; Label is in UNICODE
                jz      gs_00
                dec     ecx                             ; Skip terminating NUL
                cmp     ecx, SIZE ser_vol_label
                jbe     gs_00
                mov     ecx, SIZE ser_vol_label
gs_00:
                ;
                ; Clear label ( 11 bytes )
                ;
                mov     eax, 20202020H
                mov     [esi], eax
                mov     [esi+4], eax
                mov     [esi+8], ax
                mov     [esi+10], al

                ;
                ; Copy
                ;
                xchg    edi, esi
                lea     esi, [esi].vi_label
gs_01:
                mov     al, [esi]
                stosb
                add     esi, 2
                loop    gs_01

                pop     edi                             ; ptr to client buf

                ;
                ; Copy filesystem name ( 8 bytes )
                ;
                mov     eax, 20202020H                  ; Clear first
                lea     edi, [edi].ser_fs_type
                mov     [edi], eax
                mov     [edi+4], eax

                mov     ecx, CDIFS_NAME_LEN
                mov     esi, OFFSET32 CDIFS_NAME
                rep     movsb

                xor     eax, eax
                mov     [edx].Client_AX, ax
                ret
GetSerial       ENDP

;----------------------------------------------
; CDIFS_IOCtl16
;
; 16-bit IOCTL support
;
; IN:   ptr to ioreq in TOS+4
;
;----------------------------------------------
_CDIFS_IOCtl16  PROC
                PUBLIC  _CDIFS_IOCtl16

                push    ebp
                mov     ebp, esp
                push    esi
                push    edi
                push    ebx

                mov     ebx, [ebp+8]                    ; Get ptr to ioreq
                mov     edi, [ebx].ir_rh                ; Get ptr to LPCDIFS_VOLUME
                mov     edx, [ebx].ir_aux2.aux_ptr
                mov     si,  [edx].Client_AX            ; Get function code

                ;
                ; 32-bit IOCTL ?
                ;
                test    [ebx].ir_options, IOCTL_PKT_LINEAR_ADDRESS
                jz      ioctl_0

                mov     ecx, [ebx].ir_data
                jmp     ioctl_03
ioctl_0:
                mov     ax, (Client_DS SHL 8) + Client_DX
                VMMCall Map_Flat
                mov     ecx, eax
ioctl_1:
                ;
                ; Setup CLIENT_AX
                ;
                cmp     si, 440DH
                jnz     ioctl_03

                mov     ax, [edx].Client_CX
                and     ah, 0fh
                cmp     ax, 0866H
                jnz     ioctl_03

                call    GetSerial
                jmp     ioctl_end
ioctl_03:
                mov     [esi].IOR_ioctl_function, si

                push    edi
                call    _AllocIOP                       ; Allocate IOP
                add     esp,4                           ; EAX = ptr to IOR

                mov     esi, eax
                mov     [esi].IOR_func, IOR_GEN_IOCTL
                test    [ebx].ir_options, IOCTL_PKT_LINEAR_ADDRESS
                jnz     ioctl_04
                or      [esi].IOR_flags, IORF_16BIT_IOCTL
ioctl_04:
                mov     [esi].IOR_ioctl_buffer_ptr, ecx
                mov     [esi].IOR_ioctl_client_params, edx

                ;
                ; Setup CLIENT_BX
                ;
                mov     ax, [edx].Client_BX
                mov     [esi].IOR_ioctl_drive, ax

                ;
                ; Setup CLIENT_CX
                ;
                movzx   eax, [edx].Client_CX
                mov     [esi].IOR_ioctl_control_param, eax

                ;
                ; Do IOS call
                ;
                push    esi                             ; Save IOR ptr
                push    edx                             ; Save ptr to Client_Regs
                push    ebx                             ; Save ptr to IOREQ
                mov     edi, [edi].vi_dcb               ; Get DCB ptr
                VxDCall IOS_SendCommand                 ; Call IOS
                pop     ebx                             ; Restore ptr to IOREQ
                pop     edx                             ; Restore Client_Regs ptr
                pop     esi                             ; Restore IOR ptr

                mov     eax, [esi].IOR_ioctl_return
                mov     [edx].Client_AX, ax

                cmp     [esi].IOR_status, IORS_ERROR_DESIGNTR
                jae     ioctl_2
                xor     eax, eax
ioctl_2:
                ;
                ; Release IOP
                ;
                push    esi
                call    _FreeIOP
                add     esp, 4

ioctl_end:
                mov     [ebx].ir_error, ax

                pop     ebx
                pop     edi
                pop     esi
                pop     ebp
                ret
_CDIFS_IOCtl16  ENDP

VxD_CODE_ENDS

END
