MAX_CDI_VOL_ID          EQU   32
MAX_CDI_ALBUM_ID        EQU   128
MAX_CDI_PUBLISHER_ID    EQU   128
MAX_CDI_PREPARER_ID     EQU   128
MAX_CDI_APPLICATION_ID  EQU   128
MAX_CDI_DATETIME        EQU   16

CDIFS_VOLUME                  STRUC
        vi_next               dd      ?
        vi_media_handle       dd      ?
        vi_dcb                dd      ?
        vi_vrp                dd      ?
        vi_drive              db      ?
        vi_ptbl_size          dd      ?
        vi_ptbl               dd      ?
        vi_size               dw      ?
        vi_serial             dd      ?
        vi_filelist           dd      ?
        vi_nfiles             dd      ?
        vi_label_size         dd      ?
        vi_label              db      MAX_CDI_VOL_ID * 2 dup(?)
        vi_volume_id_len      dd      ?
        vi_volume_id          db      MAX_CDI_VOL_ID dup(?)
        vi_album_id_len       dd      ?
        vi_album_id           db      MAX_CDI_ALBUM_ID dup(?)
        vi_publisher_id_len   dd      ?
        vi_publisher_id       db      MAX_CDI_PUBLISHER_ID dup(?)
        vi_preparer_id_len    dd      ?
        vi_preparer_id        db      MAX_CDI_PREPARER_ID dup(?)
        vi_application_id_len dd      ?
        vi_application_id     db      MAX_CDI_APPLICATION_ID dup(?)
        vi_creation_date      db      MAX_CDI_DATETIME dup(?)
        vi_modification_date  db      MAX_CDI_DATETIME dup(?)
        vi_expiration_date    db      MAX_CDI_DATETIME dup(?)
        vi_effective_date     db      MAX_CDI_DATETIME dup(?)
        vi_volume_set_size    dd      ?
        vi_volume_seq_number  dd      ?
CDIFS_VOLUME                  ENDS

CDIFS_CONFIG  STRUCT
        cfg_mount_flags dd  ?
CDIFS_CONFIG  ENDS

;
; CDIFS File System functions
;
CDIFS_MountVolume       equ     _CDIFS_MountVolume
CDIFS_NAME              equ     _CDIFS_NAME

extrn   CDIFS_MountVolume: near
extrn   CDIFS_NAME: near

CDIFS_NAME_LEN   EQU    5                       ; There are 5 chars in "CDIFS"
NUM_CACHE_BLOCKS EQU    16                      ; We will use this much of 4K cache blocks

IO_READF_RAW     EQU    1                       ; Flag values for IO_ReadBlock

RAW_SECT_SIZE    EQU    2352
COOKED_SECT_SIZE EQU    2048
